

#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 Green
#property indicator_width1 2

#property indicator_color2 FireBrick
#property indicator_width2 2

#property indicator_color3 Black
#property indicator_width3 2

#property indicator_color4 Green
#property indicator_width4 0

#property indicator_color5 FireBrick
#property indicator_width5 0

#property indicator_color6 Black
#property indicator_width6 4

extern bool    ShowPriceLine = True;
extern int     PriceLineWindow = 1;

extern string Group = "Grp1";

extern string  Pair1 = "EURUSD";
extern string  Pair2 = "NZDUSD";
extern string  Pair3 = "AUDUSD";
extern string  Pair4 = "GBPUSD";
int            Tperiod = 0;

//---- buffers

double BbufferGreen[];
double BbufferRed[];
double ObufferBlack[];
double HbufferGreen[];
double HbufferRed[];
double LbufferBlack[];
//+------------------------------------------------------------------+




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

   string short_name=Group+" BBrs";
   IndicatorShortName(short_name);

//---- indicators
   
   SetIndexBuffer(0,BbufferGreen);
   SetIndexStyle(0,DRAW_HISTOGRAM,0);
   SetIndexLabel(0,"BasketClose"); 
    
   SetIndexBuffer(1,BbufferRed);
   SetIndexStyle(1,DRAW_HISTOGRAM,0);
   SetIndexLabel(1,NULL); 

   SetIndexBuffer(2,ObufferBlack);
   SetIndexStyle(2,DRAW_HISTOGRAM,0);
   SetIndexLabel(2,"BasketOpen");
      
   SetIndexBuffer(3,HbufferGreen);
   SetIndexStyle(3,DRAW_HISTOGRAM,0);
   SetIndexLabel(3,"BasketHigh");
   
   SetIndexBuffer(4,HbufferRed);
   SetIndexStyle(4,DRAW_HISTOGRAM,0);
   SetIndexLabel(4,NULL);
    
   SetIndexBuffer(5,LbufferBlack);
   SetIndexStyle(5,DRAW_HISTOGRAM,0);
   SetIndexLabel(5,"BasketLow"); 
 
 
double cb; 
if (ShowPriceLine==True) ObjectCreate(Group+"CurrentPrice",OBJ_HLINE,PriceLineWindow,Green,cb); 
//----
return(0);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
ObjectDelete(Group+"CurrentPrice");
return(0);
}
//+------------------------------------------------------------------+
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

   int    counted_bars=IndicatorCounted();
   double ch,cl,cb,co;

   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted

   if(counted_bars>0) counted_bars--;

   int pos=Bars-counted_bars;
  
   while (pos>=0) 
   {
   
            ch =  gethigh(Pair1,Tperiod,pos)+
                  gethigh(Pair2,Tperiod,pos)+
                  gethigh(Pair3,Tperiod,pos)+
                  gethigh(Pair4,Tperiod,pos);
            
            cl =  getlow(Pair1,Tperiod,pos)+
                  getlow(Pair2,Tperiod,pos)+
                  getlow(Pair3,Tperiod,pos)+
                  getlow(Pair4,Tperiod,pos);
 
      
            cb =  getbid(Pair1,Tperiod,pos)+
                  getbid(Pair2,Tperiod,pos)+
                  getbid(Pair3,Tperiod,pos)+
                  getbid(Pair4,Tperiod,pos);


            co =  getopen(Pair1,Tperiod,pos)+
                  getopen(Pair2,Tperiod,pos)+
                  getopen(Pair3,Tperiod,pos)+
                  getopen(Pair4,Tperiod,pos);
               




      if (ShowPriceLine==True) ObjectSet(Group+"CurrentPrice",OBJ_HLINE,cb);

      if (cb >= co)         //  up bar
         {   
            BbufferGreen[pos] = cb;
         
            BbufferRed[pos] = co;
            ObufferBlack[pos] = co;

            HbufferGreen[pos] = ch;
         
            HbufferRed[pos] = cl;
            LbufferBlack[pos] = cl;
            
            if (ShowPriceLine==True) ObjectSet(Group+"CurrentPrice",OBJPROP_COLOR,Green);
         }
      else                 //  down bar
         {
            BbufferRed[pos] = co;
         
            BbufferGreen[pos] = cb;         
            ObufferBlack[pos] = cb;

            HbufferRed[pos] = ch;
         
            HbufferGreen[pos] = cl;
            LbufferBlack[pos] = cl;
            
            if (ShowPriceLine==True) ObjectSet(Group+"CurrentPrice",OBJPROP_COLOR,FireBrick);
         }

     pos--;
   }
   
   
//----
return(0);
}
  
  
//+------------------------------------------------------------------+

double gethigh(string c,int tf, int ni)
   {
     if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   chigh = iHigh(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(chigh);
   }   

double getlow(string c,int tf, int ni)
   {
      if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   clow = iLow(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(clow);
   } 
   
double getbid(string c,int tf, int ni)
   {
      if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   cbid = iClose(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(cbid);
   }     

  
double getopen(string c,int tf, int ni)
   {
      if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   copen = iOpen(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(copen);
   }     
             